﻿using FarseerPhysics.Collision.Shapes;
using FarseerPhysics.Dynamics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace XFORGE.StillCharging
{
    class Asteroid : Entity
    {
        private static Random random = new Random();

        public Asteroid(Vector2 position)
            : base(Textures["asteroid_normal"], position)
        {
            //Random random = new Random();
            AngularDamping = 0;
            FixedRotation = false;

            if (random.Next(10) == 0)
            {
                texture = Textures["asteroid_large"];
                origin = new Vector2(texture.Width / 2, texture.Height / 2);
                CreateFixture(new CircleShape(ConvertUnits.ToSimUnits(40), 10));
            }
            else
            {
                CreateFixture(new CircleShape(ConvertUnits.ToSimUnits(24), 10));
            }

            ApplyAngularImpulse((float)random.Next(10) / 10.0f - 0.5f);
            //AngularVelocity = (float)random.Next(10) - 5f;
            ApplyLinearImpulse(new Vector2(random.Next(5) - 2.5f, random.Next(5)));
        }
    }
}
