﻿using FarseerPhysics.Collision.Shapes;
using FarseerPhysics.Dynamics;
using FarseerPhysics.Dynamics.Contacts;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace XFORGE.StillCharging
{
    class LaserBolt : Entity
    {
        public LaserBolt(Vector2 position, float rotation)
            : base(Textures["laser_small_bolt"], position, rotation)
        {
            IsBullet = true;

            AttachTextureFixture(0.0f);

            OnCollision += LaserBolt_OnCollision;
        }

        bool LaserBolt_OnCollision(Fixture fixtureA, Fixture fixtureB, Contact contact)
        {
            if (fixtureB.Body is Shield)
                return false;

            DespawnQueue.Enqueue(this);

            return true;
        }
    }
}
