﻿using FarseerPhysics.Dynamics;
using FarseerPhysics.Dynamics.Contacts;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace XFORGE.StillCharging
{
    class Shield : SubEntity
    {
        private float initialRotation;

        private float energy;

        public float Energy
        {
            get
            {
                return energy;
            }
            set
            {
                energy = MathHelper.Clamp(value, 0, 100);
            }
        }

        public Shield(Entity parent, Vector2 offset, float rotation)
            : base(Textures["shield_small"], parent, offset, rotation)
        {
            initialRotation = rotation;

            Energy = 100.0f;

            FixedRotation = true;

            AttachTextureFixture(1f);

            OnCollision += Shield_OnCollision;
        }

        bool Shield_OnCollision(Fixture fixtureA, Fixture fixtureB, Contact contact)
        {
            if (fixtureB.Body is LaserBolt)
            {
                return false;
            }
            else
            {
                if (Energy > 20.0f)
                {
                    Energy -= 20.0f;
                    fixtureB.Body.ApplyForce(offset * 200);
                }
                else
                {
                    return false;
                }
            }

            return true;
        }

        public override void Update(GameTime gameTime)
        {
            Rotation = parent.Rotation + initialRotation;

            Energy -= 10 * (float)gameTime.ElapsedGameTime.TotalSeconds;

            base.Update(gameTime);
        }

        public override void Draw(SpriteBatch spriteBatch)
        {
            opacity = Energy / 100.0f;

            base.Draw(spriteBatch);
        }
    }
}
