﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace XFORGE.StillCharging
{
    class SubEntity : Entity
    {
        protected Entity parent;

        protected Vector2 offset;

        public SubEntity(Texture2D texture, Entity parent, Vector2 offset, float rotation)
            : base(texture, parent.Position + offset, rotation)
        {
            this.parent = parent;
            this.offset = offset;
        }

        public override void Update(GameTime gameTime)
        {
            Position =
                parent.Position +
                Vector2.Transform(offset, Matrix.CreateRotationZ(parent.Rotation)
                );

            base.Update(gameTime);
        }
    }
}
